/*HARDWARE:
 * Timer 4: interrupción cada 100ms
 * Timer 5: señal PWM de frecuencia 500Hz
 * A0: pin AD590
 * A1: pin NTC
 * A2: pin PT100
 * A3: pin Termopar
 * A5: pin Consigna
 * A6: pin Kp
 * A7: pin Ki
 * A8: pin Kd
 * A9: pin VelVentilador
 * 46: pin salida señal PWM resistencia
 * 50: pin interruptor modo          
 * 52: pin interruptor ventilador    
 * 04: pin PWM Ventilador            
 * 22: pin selector AD590            
 * 24: pin selector Termopar         
 * 26: pin selector PT100            
 * 28: pin selector NTC              
*/
#ifndef Funciones_h
#define Funciones_h

#define pinAD590 A0 
#define pinNTC A1 
#define pinPT100 A2 
#define pinTermopar A3
#define pinConsigna A5
#define pinKp A6
#define pinKi A7
#define pinKd A8
#define pinVelVentilador A9
#define pinIntModo 50 
#define pinPWMVentilador 4
#define pinIntVentilador 52 
#define pinPWM 46
#define pinSelec_AD590 22
#define pinSelec_Termopar 24
#define pinSelec_PT100 26
#define pinSelec_NTC 28

#define TempMax 110

//VARIABLES EXTERNAS
extern int Temperatura;
extern int Tmuestreo;
extern int Modo;
extern int inicio_PC;

//INTERRUPCIÓN 500ms
void configTimer4Interrupt();

//SENSORES
void FiltradoAD();
void FiltradoNTC();
void FiltradoPT();
void FiltradoK();
void Calc_Temp_ad590(int pinAD590);
void Calc_Temp_ntc(int pinNTC);
void Calc_Temp_pt100(int pinPT100);
void Calc_Temp_termopar(int pinTermopar);
void initFiltros();

//ENTRADAS
void Lect_Entradas_Manual();
void Lect_Entradas_PC();
void Enviar_Datos_PC();

//VENTILADOR 
void Control_Ventilador();

//CONTROL PID
void Params_PID();
void Control_PID();

//RESISTENCIA PWM
void configTimerPWM();
void Resistencia_PWM();
void AlertaEnfriamiento();

//LCD
void init_lcd();
void imprimir_saludo();
void imprimir_modo();
void imprimir_titulos();
void imprimir_temp();
void imprimir_consig();
void imprimir_error();
void imprimir_Kp();
void imprimir_Ki();
void imprimir_Kd();
void imprimir_DC();

#endif //Funciones_h
