#include "Funciones.h"//Cabecera con las declaraciones 

void setup() {
  pinMode(pinIntModo,INPUT_PULLUP); //configura el pin como entrada con R pull-up
  pinMode(pinIntVentilador,INPUT_PULLUP); 
  pinMode(pinSelec_AD590,INPUT_PULLUP); 
  pinMode(pinSelec_Termopar,INPUT_PULLUP);
  pinMode(pinSelec_PT100,INPUT_PULLUP);
  pinMode(pinSelec_NTC,INPUT_PULLUP); 
  pinMode(pinPWMVentilador,OUTPUT); //configura el pin como salida
  pinMode(pinPWM,OUTPUT);
  initFiltros(); //inicia el filtrado de temperaturas
  init_lcd(); //inicia el display LCD
  imprimir_saludo(); //imprime mensaje en pantalla
  imprimir_titulos(); //imprime los nombres en pantalla
  configTimerPWM(); //Configura el temporizador 5 para generar la señal PWM
  configTimer4Interrupt(); //Configura el temporizador 4 para realizar interrupciones
}

void loop() { 
  //Actualiza los datos en pantalla
  imprimir_temp(); 
  imprimir_consig(); 
  imprimir_error(); 
  imprimir_modo();
  imprimir_Kp(); 
  imprimir_Ki(); 
  imprimir_Kd(); 
  imprimir_DC(); 
  if(Tmuestreo==1){ //Flag interrupción 
    //Detiene el contador
    TCCR4B = (0<<ICNC4)|(0<<ICES4)|(0<<5)|(0<<WGM43)|(1<<WGM42)|(0<<CS42)|(0<<CS41)|(0<<CS40);
    TIMSK4 = (0<<ICIE4)|(0<<OCIE4B)|(0<<OCIE4A)|(0<<TOIE4);//Deshabilita la interrupción
    if(Temperatura > TempMax){ //La temperatura supera el límite
      AlertaEnfriamiento(); //Enfriamiento forzado
    }
    Calc_Temp_pt100(pinPT100); //Calcula la temperatura del sensor
    FiltradoPT(); //Filtrado de la temperatura
    Calc_Temp_ad590(pinAD590); 
    FiltradoAD(); 
    Calc_Temp_ntc(pinNTC);
    FiltradoNTC();
    Calc_Temp_termopar(pinTermopar);
    FiltradoK();
    Modo=digitalRead(pinIntModo); //Lectura del interruptor de Modo
    if(Modo==1){//Modo Manual
      if(inicio_PC==1){ //Estaba en modo PC
        inicio_PC=0; //Limpia el flag
        Serial.end(); //Cierra la comunicación serial
      }
      Lect_Entradas_Manual(); //Lectura de las entradas del panel frontal
    }else{//Modo PC
      if(inicio_PC==0){ //Estaba en modo Manual
        Serial.begin(115200); //Inicia comunicación serial
        inicio_PC=1; //Activa el flag del modo PC
      }
      if (Serial.available() >= 6) { //Se han recibido todos los datos
        Lect_Entradas_PC(); //Lectura del buffer de entrada
      }
    }
    Control_Ventilador(); //Controla el ventilador
    Control_PID();//Calcula el control PID
    Resistencia_PWM(); //Aplica el control PID
    if(Modo==0){ //Modo PC
      Enviar_Datos_PC(); //Envía los datos al PC
    }
    Tmuestreo=0; //Resetea flag interrupción
    TCNT4 = 0; //Resetea el contador
    //Activa el contador
    TCCR4B = (0<<ICNC4)|(0<<ICES4)|(0<<5)|(0<<WGM43)|(1<<WGM42)|(0<<CS42)|(1<<CS41)|(1<<CS40);
    TIMSK4 = (0<<ICIE4)|(0<<OCIE4B)|(1<<OCIE4A)|(0<<TOIE4);//Habilita la interrupción
  } 
}
